// 3
#include "pgraph.h"

#define F 3000
#define W 1675
#define H 1450
#define A 720
#define X1 2
#define X2_MIN 10
#define X2_MAX 1682
#define DX 8
#define X3 842
#define Y12 2
#define EPS 4

image *img;

void save(image *img)
{	
	static int count = 0;
	char filename[17];
	sprintf(filename, "results\\%04d.bmp", ++count);
    save_to_file(img, filename);
}

void create_int_triangles(double x1, double x2, double y12, double x3, double y3)
{
	double p = (x1 + x2) / 2;
	double q = (x1 + x3) / 2;
	double r = (y12 + y3) / 2;
	double s = (x2 + x3) / 2;
	uint up = round(p), uq = round(q), ur = round(r), us = round(s), uy12 = round(y12);
	img->cur_pnt = (point) {up, uy12};
	line_to(line_to(line_to(img, us, ur), uq, ur), up, uy12);
	if (s - q < EPS)
		return;
	create_int_triangles(q, s, r, x3, y3);
	create_int_triangles(x1, p, y12, q, r);
	create_int_triangles(p, x2, y12, s, r);
}

void create_serp_triangle(uint x1, uint x2, uint y12)
{
	uint x3 = (x1 + x2) / 2;
	uint y3 = y12 - 1 + round((x2 - x1 + 1) * 0.86602540378);
	img->cur_pnt = (point) {x1, y12};
	line_to(line_to(line_to(img, x2, y12), x3, y3), x1, y12);
	create_int_triangles(x1, x2, y12, x3, y3);
}

int main()
{
	img = create_image(W, H);
	image *img2 = create_image(A, A);
	for (uint i = 0, x = X2_MIN; i < F; i++, x += DX)
	{	
		if (x == X2_MAX)
			x = X3;
		fill_all(img, WHITE);
		create_serp_triangle(X1, x, Y12);
		copy_rect(img, 0, 0, A, A, img2, 0, 0);
		save(img2);
	}
	free(img);
	free(img2);
	return 0;
}
